//******************************************
//  : MQ6832_TC0
// 汾     : V 1.00
//      : TC0ʹú
// ע     :
//******************************************

#include "main.h"




//*********************************************************************
//    : TC00_Timer_Init
//  : TC00 8λrģʽr100us
// ע     :
//*********************************************************************
void TC00_Timer_Init(void)
{
//====== ܿ( Enable) ======
    POFFCR0_TC001EN = 1;                // ȿݴò

//====== 趨 ======
    T00MOD_TCM      = 0;                // 趨Ϊ 8 λʱģʽ
    T00MOD_TCK      = 5;                // fcgck/4 = 1MHz = 1us
    T00MOD_DBE      = 1;                // ʹ˫
    T00REG          = 100;              // 趨ֵ: ÿ 100 * 1us = 100us жһ
}


//*********************************************************************
//    : TC00_PPG_Init
//  : TC00 8λPPGģʽL100usռձ50%
// ע     :
//*********************************************************************
void TC00_PPG_Init(void)
{
//====== ܽųʼ ======
    P7DR_P0         = 1;                // ܽʼͬ PPG ĳʼֵ(T0xMOD_TFF)
    P7CR_P0         = 1;                // ܽ趨Ϊ

//====== ܿ( Enable) ======
    POFFCR0_TC001EN = 1;                // ȿݴò

//====== 趨 ======
    T00MOD_TFF      = 1;                // 趨ʼֵΪ׼λռձ
//	PxFC ùţڳʼֵ趨֮ PxFC
    P7FC_P0         = 1;                // ܽ趨Ϊ PPG 

    T00MOD_TCM      = 3;                // 趨Ϊ 8 λɱ PPG ģʽ
    T00MOD_TCK      = 5;                // fcgck/4 = 1MHz = 1us
    T00MOD_DBE      = 1;                // ʹ˫

    T00REG          = 100;              // 趨 PPG  = 100us
    T00PWM          = 50;               // 趨 PPG ռձ = 50/100 = 50%
}


//*********************************************************************
//    : TC00_PWM_Init
//  : TC00 8λPWMģʽL128usռձ50%
// ע     :
//*********************************************************************
void TC00_PWM_Init(void)
{
//====== ܽųʼ ======
    P7DR_P0         = 1;                // ܽʼͬ PWM ĳʼֵ(T0xMOD_TFF)
    P7CR_P0         = 1;                // ܽ趨Ϊ

//====== ܿ( Enable) ======
    POFFCR0_TC001EN = 1;                // ȿݴò

//====== 趨 ======
    T00MOD_TFF      = 1;                // 趨ʼֵΪ׼λռձ
//	PxFC ùţڳʼֵ趨֮ PxFC
    P7FC_P0         = 1;                // ܽ趨Ϊ PWM 

    T00MOD_TCM      = 2;                // 趨Ϊ 8 λɱ PWM ģʽ
    T00MOD_TCK      = 5;                // fcgck/4 = 1MHz = 1us
    T00MOD_DBE      = 1;                // ʹ˫

// ʹ PWM ʱڼ̶Ϊ 128T00REG 趨
// 128 * 1us = 128us
    T00PWM          = 128;              // 趨 PWM ռձ = (128/2)/128 = 50%
}


//*********************************************************************
//    : TC00_SetDuty
//  : O}Ӌֵ
// ע     : ռձ : T00PWM/T00REG    (8λPPGģʽ)
//                 : (T00PWM/2) / 128 (8λPWMģʽ
//*********************************************************************
void TC00_SetDuty(uchar duty)
{
    T00PWM          = duty;
}

//*********************************************************************
//    : TC00_SetPeriod
//  : OLӋֵ
// ע     : 
//*********************************************************************
void TC00_SetPeriod(uchar period)
{
    T00REG          = period;
}

//*********************************************************************
//    : TC00_Start
//  : TC00
// ע     :
//*********************************************************************
void TC00_Start(void)
{
    T001CR_T00RUN   = 1;                // ʱ
}


//*********************************************************************
//    : TC00_Stop
//  : ֹͣTC00
// ע     :
//*********************************************************************
void TC00_Stop(void)
{
    T001CR_T00RUN   = 0;                // ֹͣʱ
}


//*********************************************************************
//    : TC00_IntEnable
//  : TC00ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TC00_IntEnable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IL_INTTC00      = 0;                // ж
    EI_INTTC00      = 1;                // 趨ж
    EI;                                 // пж // EIRL_IMF=1
}



//*********************************************************************
//    : TC00_IntDisable
//  : ֹTC00ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TC00_IntDisable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    EI_INTTC00      = 0;                // ж
	IL_INTTC00      = 0;                // ж    
    EI;                                 // пж // EIRL_IMF=1
}



//*********************************************************************
//    : IntTC00
//  : жϸʽ
// ע     :
//*********************************************************************
void __interrupt IntTC00(void)
{    
	P9DR_P0 = !P9DR_P0;
    NOP;                                // ָ
}




























