//******************************************
//  :
// 汾     :
//      :
// ע     :
//******************************************
#ifndef _MQ6832_ADC_H_
#define _MQ6832_ADC_H_



#define     AD_TIMES       16

/******************
 * 1st Argument
 * ****************/
#define     ADC_SINGLE      0x1 // תģʽ
#define     ADC_REPEAT      0x3 // תģʽ
/******************
 * 2nd Argument
 * ****************/
#define     AIN_DIS         0x0 // ֹģź
#define     AIN_EN          0x1 // ģź
/******************
 * 3rd Argument
 * ****************/
#define     AIN0            0x0 // ѡⲿѹAIN0
#define     AIN1            0x1 // ѡⲿѹAIN1
#define     AIN2            0x2 // ѡⲿѹAIN2
#define     AIN3            0x3 // ѡⲿѹAIN3
#define     AIN4            0x4 // ѡⲿѹAIN4
#define     AIN5            0x5 // ѡⲿѹAIN5
#define     AIN6            0x6 // ѡⲿѹAIN6
#define     AIN7            0x7 // ѡⲿѹAIN7
#define     AIN8            0x8 // ѡⲿѹAIN8
#define     VDD4_1          0x9 // ѡڲѹ (4֮1 VDD)
#define     AIN_GND         0xc // ڲӵ
#define     AIN13           0xd // ѡⲿѹAIN13
#define     AIN14           0xe // ѡⲿѹAIN14
#define     AIN15           0xf // ѡⲿѹAIN15
/******************
 * 4th Argument
 * ****************/
// fcgck=16M... CONV256CLK(16us) ~ CONV1024CLK( 64us)
// fcgck= 8M... CONV128CLK(16us) ~ CONV1024CLK(128us)
// fcgck= 4M... CONV64CLK (16us) ~ CONV512CLK (128us)
// fcgck= 2M... CONV32CLK (16us) ~ CONV256CLK (128us)
#define     CONV32CLK       0x0 // ADתʱ-  32ʱ
#define     CONV64CLK       0x1 // ADתʱ-  64ʱ
#define     CONV128CLK      0x2 // ADתʱ- 128ʱ
#define     CONV256CLK      0x3 // ADתʱ- 256ʱ
#define     CONV512CLK      0x4 // ADתʱ- 512ʱ
#define     CONV1024CLK     0x5 // ADתʱ-1024ʱ
                                // (*עתʱӦ趨12.8 us ~ 128 us Χ)
/******************
 * 5th Argument
 * ****************/
#define     VREF2           0x0 // ѡڲ 2Vοѹ
#define     VREF3           0x1 // ѡڲ 3Vοѹ
#define     VREF4           0x2 // ѡڲ 4Vοѹ
#define     VDDVREF         0x3 // ѡڲVDDοѹ
#define     EXTVREF         0x4 // ѡⲿExtοѹʹAIN3ͬĵ28(P43)Ϊ
								// ⲿοѹ룬ⲿοѹʱʹAIN3Ϊⲿѹ





extern uint  vref_l, vref_h, iReal_Vref2V, ADC_Code_READ;



void ADC_Init();
void ADC_Start(void);
void ADC_Stop(void);
void ADC_IntEnable(void);
void ADC_IntDisable(void);

uint GetVref(void);
uint ADC_SingleDetect(uchar SAIN);
uint ADC_RepeatDetect(uchar SAIN);

void __interrupt IntADC(void);






#endif








